#include <dos.h>
#include <alloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <mem.h>
#include "struct.hpp"
#include "motor_i.hpp"

#define valpor 0.0392156862745098


char init(void);  // funcion para inicializar el motor de inferencia
void motor_inferencia(double *vbles_entrada, double *vbles_salida);
			// funcion que realiza una interaccion del motor.

void Ventana_errores(char * Linea1,char *Linea2,char *Linea3); //botones.cpp
void mensaje(char *texto); // botones.cpp
// Funcion modificable para intoducir el control por medio de un conversor
// por defecto se simula leyendo los datos de fichero;
char final( double *valores_entrada,int n_entradas,double *valores_salida,int n_salida);
void leer_entradas(double *valores_entradas, int n_entradas);
void enviar_salidas(double *valores_salida, int n_sallidas);

void conver(void)
	{
	 extern vble *vble_entrada;
	 extern vble *vble_salida;
	 extern lis_reg *lista_reglas;
	 extern int n_entradas ;
	 extern int n_salidas  ;

	 int i;
	 FILE **desc;
	 vble *p;
	 char fin = 0;
	 int cont;
   double *v_entrada, *v_salida; // son los dos array con los que nos
   																	 //	comunicaremos con la funcion
	 																	// que realiza en control.


   if (init()!= 0) // funcion que inicializa el sistema para poder realizar los
  				         // clculos
  		{
       return;
			}

   // damos memoria a los array de conmunicacion

	 v_entrada = ( double * )malloc(sizeof(double) * n_entradas);
   if ( v_entrada == NULL)
   	{
     printf("ERROR: memoria insuficiente");
     exit(-1);
		}
	 v_salida = ( double * ) malloc(sizeof(double) * n_salidas);
   if ( v_salida == NULL)
		{
		 printf("ERROR: memoria insuficiente");
		 exit(-1);
		}
	 memset(v_entrada,0,sizeof(double) * n_entradas);


	 cont = 0; // vble que cuenta el n de interacciones realizadas

	 do
		{
		 char buf[255];
		 cont ++;
		 sprintf(buf,"Interacciones realizadas : %d",cont);
		 mensaje(buf);
		 leer_entradas(v_entrada,n_entradas);
		 motor_inferencia(v_entrada, v_salida);  // se ejecuta una interaccion
																						// del motor de inferencia
					//  la funcion devuelve en v_salida , los diferntes valores de las
					//  vbles de salida del sistema, al igual que con las entradas,
					//  en el orden en que se hayan definido en el sistema
		 enviar_salidas(v_salida,n_salidas);
		}
	while ( final(v_entrada,n_entradas,v_salida,n_salidas)); // bucle que realizar el control

	free(v_entrada);
	free(v_salida);
	mensaje("");
 }





            /* Funciones definidas por el Usuario */


char final( double *valores_entrada,int n_entradas,double *valores_salida,int n_salida)
	{
        /* Parmetros:
	   valores_entrada = array con los valores de entrada de la ltima interaccion
	  valores_salida = array con los valores de salida de la ltima interaccion
	 la funcin debe devolver un uno si se quiere continuar con el proceso o un cero
	 si se desea parar
        */
	if(valores_salida==0)
		return 0;
	else
		return 1;
	}

/* funcin para leer los valores desde el conversor*/
void leer_entradas(double *valores_entradas, int n_entradas)
	{
	int dato=0;
	unsigned char signo;

	outportb(0x503,0x90);         /*programo puerto*/
	outportb(0x502,0x18);         /* Programa puerto lectura  */
	delay(1);
	signo=inportb(0x500);         /* Lectura signo            */
	signo=signo & 1;
	outportb(0x502,0x98);         /* Programa puerto lectura  */
	delay(1);
	dato=inportb(0x500);          /* Lectura del dato         */

	if(signo)  dato=(-dato);      /* si negativo complemento  */
	dato=dato*valpor;


	valores_entradas[1]=(float)(dato-valores_entradas[0]);
	valores_entradas[0]=((float)dato);    /* se almacena en el array  */
	 return;
	}



/* funcin para enviar las salidas al conversor */
void enviar_salidas(double *valores_salida, int n_sallidas)
	{
		int dato=0;

		outportb(0x503,0x90);

		if(valores_salida[0]>9.9) valores_salida[0]=9.9;
		if(valores_salida[0]<0)   valores_salida[0]=0;

		dato=(int)(valores_salida[0]/valpor);
		outportb(0x501,(dato>=0)? abs(dato):0);

		if (dato>=0)
			outportb(0x502,0x10);
		else
			outportb(0x502,0x90);

		delay(0.05);
		outportb(0x502,0x00);
		return;
	}
