#include <io.h>
#include <fcntl.h>
#include <graphics.h>
#include <conio.h>
#include <STRING.H>
#include <ALLOC.H>
#include <PROCESS.H>
#include <STDIO.H>
#include "graton.hpp"
#include "image.hpp"
#include "boton.hpp"


//
//          D E F I N I C I O N   D E   C O N S T A N T E S
//

#define BOTON_UP 0
#define BOTON_DOWN 1
#define BARRAX 5
	// "imag_sat.cpp"
#define BARRAY 10
#define ALTURA 50
#define NUM_BOTONES 10
#define MAX_BOTONES 17
#define NO_PULSADO   0
#define PULSADO      1
#define ACTIVO       0
#define INACTIVO     1
#define ICONO_TEXTO  0
#define ICONO_GRAF   1


//
//          D E F I N I C I O N   D E   P R O T O T I P O S
//


void boton_down(int xup,int yup,int tamx,int tamy,int grosor,int COLOR_BOTON);
void boton_up(int xup,int yup,int tamx,int tamy,int grosor,int COLOR_BOTON);
void activar_boton(int xup,int yup,int tamx,int tamy,int grosor);
void desactivar_boton(int xup,int yup,int tamx,int tamy,int grosor);
void dibujar_boton(int xup,int yup,int tamx,int tamy,int grosor,
				int COLOR_BOTON,int OPC);
void dibujar_boton2(int xup,int yup,int tamx,int tamy,int grosor,int COLOR_BOTON);
void sombrear_boton(int Num_boton,int grosor);
void init_botom(void);
void test_botones(void);
void inactivar_boton(BOTON boton);
void mensaje(char *texto);
void cargar_icono(int i,char *nombre);
void showTFE256 (int posx, int posy, unsigned char far *buffer,int tamx,int tamy);
int  gestion_boton(int *Ult_boton);
void test_boton(BOTON boton);
int boton_pulsado(BOTON far *botones,int Num_botones);
void bvd(void);
char Ventana_confirmacion(char *Titulo,char * Linea1,char *Linea2,char *Linea3);
void Ventana_errores(char * Linea1,char *Linea2,char *Linea3);
void mostrar_info(int xpant,int ypant);
void entrada(void); //"GRaton.cpp"


void pantalla(void)
{
 int i,j;
 extern GRaton raton;


/*Fondo*/
 setfillstyle(SOLID_FILL,LIGHTGRAY);
 bar(0,0,getmaxx(),getmaxy());
/*Barra de botones*/
 dibujar_boton(BARRAX,BARRAY,NUM_BOTONES * ALTURA + 20,ALTURA+16,2,LIGHTGRAY,0);

 for(i=0; i<NUM_BOTONES; i++)
	dibujar_boton(BARRAX+10+50*i,BARRAY+8,ALTURA,ALTURA,2,LIGHTGRAY,0);

//Barra de ayuda
 dibujar_boton(BARRAX,BARRAY+ALTURA + 25,NUM_BOTONES * ALTURA + 20,40,2,LIGHTGRAY,1);

//Recuadro de la imagen
 dibujar_boton(BARRAX,150,808,608,2,CYAN,1);

//Recuadro del histograma
 dibujar_boton(NUM_BOTONES * ALTURA + 40+BARRAX-10,BARRAY,1024-NUM_BOTONES * ALTURA-35-BARRAX,
	   130,2,LIGHTGRAY,0);
 dibujar_boton(NUM_BOTONES * ALTURA + 40+BARRAX -4,BARRAY +6 ,1024-NUM_BOTONES * ALTURA-62-BARRAX-260,
	   30,2,CYAN,1);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,2);
 settextjustify(CENTER_TEXT,TOP_TEXT);
 outtextxy(643, 22,"HISTOGRAMA");
 //Botones del HISTOGRAMA
 dibujar_boton(NUM_BOTONES * ALTURA + 60+BARRAX,70,70,50,2,LIGHTGRAY,0);
 dibujar_boton(NUM_BOTONES * ALTURA + 140+BARRAX,70,70,50,2,LIGHTGRAY,0);
 //EJES DEL HISTOGRAMA
 setcolor(RED);
 line(749,BARRAY+8,749,BARRAY+108);
 line(749,BARRAY+108,1005,BARRAY+108);
 line(774,BARRAY+108,774,BARRAY+110);
 line(799,BARRAY+108,799,BARRAY+110);
 line(824,BARRAY+108,824,BARRAY+110);
 line(849,BARRAY+108,849,BARRAY+110);
 line(874,BARRAY+108,874,BARRAY+110);
 line(899,BARRAY+108,899,BARRAY+110);
 line(924,BARRAY+108,924,BARRAY+110);
 line(949,BARRAY+108,949,BARRAY+110);
 line(974,BARRAY+108,974,BARRAY+110);
 line(999,BARRAY+108,999,BARRAY+110);

 setcolor(WHITE);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
 settextjustify(CENTER_TEXT,TOP_TEXT);
 outtextxy(749, BARRAY+114,"0");
 outtextxy(774, BARRAY+114,"25");
 outtextxy(799, BARRAY+114,"50");
 outtextxy(824, BARRAY+114,"75");
 outtextxy(849, BARRAY+114,"100");
 outtextxy(899, BARRAY+114,"150");
 outtextxy(949, BARRAY+114,"200");
 outtextxy(999, BARRAY+114,"250");
//Recuadro de la paleta
 dibujar_boton(815,150,204,300,2,LIGHTGRAY,0);
 dibujar_boton(820,155,197,30,2,CYAN,1);

 dibujar_boton(830,290,60,40,2,LIGHTGRAY,0);
 dibujar_boton(830,336,60,40,2,LIGHTGRAY,0);
 dibujar_boton(830,382,60,40,2,LIGHTGRAY,0);
 setcolor(WHITE);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,2);
 settextjustify(CENTER_TEXT,TOP_TEXT);
 outtextxy(917, 163,"PALETA");
 dibujar_boton(920,190,90,248, 2,RED,1);
 for (j = 1, i = 255; i > 15; i --, j ++)
	{
	 setcolor(i);
	 line(924,194+j,1006,194+j);
	}
//Recuadro de informacin
 dibujar_boton(815,460,204,255,2,LIGHTGRAY,0);
 dibujar_boton(820,465,197,30,2,CYAN,1);

 setcolor(WHITE);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,2);
 settextjustify(CENTER_TEXT,TOP_TEXT);
 outtextxy(917, 473,"INFORMACION");
 setcolor(BLACK);
 settextstyle(1,HORIZ_DIR,2);
 settextjustify(LEFT_TEXT,TOP_TEXT);
 setusercharsize(2, 3, 2, 3);
 init_botom();
 test_botones();
}

//
// Escribe un mensaje en la lnea de ayuda de la pantalla.
//
void mensaje(char *texto)
	{
	 extern GRaton raton;

	 setfillstyle(SOLID_FILL,LIGHTGRAY);
	 settextstyle(7,HORIZ_DIR,4);
	 setusercharsize(2, 3, 2, 3);
	 settextjustify(LEFT_TEXT,CENTER_TEXT);
	 setcolor(BLACK);
	 raton.OcultaCursor();
	 bar(BARRAX +5 , BARRAY + ALTURA + 30, BARRAX + NUM_BOTONES * ALTURA + 2, BARRAY + ALTURA + 25 + 40 - 8);
	 outtextxy(BARRAX+8,BARRAY + ALTURA + 18+ 20,texto);
	 raton.MuestraCursor();
	}


//
//  Inicializa los campos del array principal de botones.
//
void init_botom(void)
{
 extern BOTON array_boton[17];
 int i;

 // Botones del men principal

 for(i=0;i<10;i++)
	{
	 array_boton[i].xup=BARRAX+10+50*i;
	 array_boton[i].yup=BARRAY+8;
	 array_boton[i].xdown=array_boton[i].xup+ALTURA-1;
	 array_boton[i].ydown=array_boton[i].yup+ALTURA-1;
	 array_boton[i].estado= NO_PULSADO;
	 array_boton[i].activo= INACTIVO;
	 array_boton[i].text_pict= ICONO_TEXTO;
	 array_boton[i].pos_icono=i*1681;
	 strcpy(array_boton[i].texto,"BOTON");
	}

 array_boton[0].activo= ACTIVO;
 array_boton[0].text_pict= ICONO_GRAF;
 array_boton[1].text_pict= ICONO_GRAF;
 array_boton[2].text_pict= ICONO_GRAF;
 array_boton[3].text_pict= ICONO_GRAF;
 array_boton[4].text_pict= ICONO_GRAF;
 array_boton[5].text_pict= ICONO_GRAF;
 // Ayuda para los botones de la pantalla principal
 strcpy(array_boton[0].ayuda,"Operaciones de fichero (cargar, salvar,etc)");
 strcpy(array_boton[1].ayuda,"Zoom de la imagen");
 strcpy(array_boton[2].ayuda,"Modificacin del brillo y contraste");
 strcpy(array_boton[3].ayuda,"Escribir en la imagen");
 strcpy(array_boton[4].ayuda,"Filtros de mediana y media");
 strcpy(array_boton[5].ayuda,"Rotacin y ecualizacin de la imagen");
 strcpy(array_boton[6].ayuda,"Ayuda pa el boton 6");
 strcpy(array_boton[7].ayuda,"Esto es una ayuda pa el boton 7");
 strcpy(array_boton[8].ayuda,"Ayuda pa el boton 8");
 strcpy(array_boton[9].ayuda,"Esto es una ayuda pa el boton 9");
 strcpy(array_boton[10].ayuda,"Ver el histograma en detalle");
 strcpy(array_boton[11].ayuda,"Histograma acumulativo o relativo");
 strcpy(array_boton[12].ayuda,"Salvar la paleta activa");
 strcpy(array_boton[13].ayuda,"Cargar la paleta de fichero");
 strcpy(array_boton[14].ayuda,"Editar la paleta activa");
 strcpy(array_boton[15].ayuda,"Recuperar la anterior transformacin");
 strcpy(array_boton[16].ayuda,"Ver la siguiente imagen transformada");

 // Botones del histograma
 array_boton[10].xup=NUM_BOTONES * ALTURA + 60+BARRAX;
 array_boton[10].yup=70;
 array_boton[10].xdown=array_boton[10].xup+70;
 array_boton[10].ydown=array_boton[10].yup+50;
 array_boton[10].estado= NO_PULSADO;
 array_boton[10].activo= INACTIVO;
 array_boton[10].text_pict= ICONO_GRAF;
 array_boton[10].pos_icono=54357L;
 strcpy(array_boton[10].texto,"VER");

 array_boton[11].xup=NUM_BOTONES * ALTURA + 140+BARRAX;
 array_boton[11].yup=70;
 array_boton[11].xdown=array_boton[11].xup+70;
 array_boton[11].ydown=array_boton[11].yup+50;
 array_boton[11].estado= NO_PULSADO;
 array_boton[11].activo= INACTIVO;
 array_boton[11].text_pict= ICONO_GRAF;
 array_boton[11].pos_icono=51753L;
 strcpy(array_boton[11].texto,"A/R");

 // Botones de la paleta
 array_boton[12].xup=830;
 array_boton[12].yup=290;
 array_boton[12].xdown=array_boton[12].xup+60;
 array_boton[12].ydown=array_boton[12].yup+40;
 array_boton[12].estado= NO_PULSADO;
 array_boton[12].activo= ACTIVO;
 array_boton[12].text_pict= ICONO_GRAF;
 array_boton[12].pos_icono=50089L;
 strcpy(array_boton[12].texto,"SALVAR");

 array_boton[13].xup=830;
 array_boton[13].yup=336;
 array_boton[13].xdown=array_boton[13].xup+60;
 array_boton[13].ydown=array_boton[13].yup+40;
 array_boton[13].estado= NO_PULSADO;
 array_boton[13].activo= ACTIVO;
 array_boton[13].text_pict= ICONO_GRAF;
 array_boton[13].pos_icono=48425L;
 strcpy(array_boton[13].texto,"CARGAR");

 array_boton[14].xup=830;
 array_boton[14].yup=382;
 array_boton[14].xdown=array_boton[14].xup+60;
 array_boton[14].ydown=array_boton[14].yup+40;
 array_boton[14].estado= NO_PULSADO;
 array_boton[14].activo= ACTIVO;
 array_boton[14].text_pict= ICONO_GRAF;
 array_boton[14].pos_icono=46761L;
 strcpy(array_boton[14].texto,"EDITAR");
 // Botones para recorrer las transformaciones de la imagen
 array_boton[15].xup=815;
 array_boton[15].yup=716;
 array_boton[15].xdown=array_boton[15].xup+102;
 array_boton[15].ydown=array_boton[15].yup+40;
 array_boton[15].estado= NO_PULSADO;
 array_boton[15].activo= INACTIVO;
 array_boton[15].text_pict= ICONO_GRAF;
 array_boton[15].pos_icono=56961L;
 strcpy(array_boton[15].texto,"");

 array_boton[16].xup=917;
 array_boton[16].yup=716;
 array_boton[16].xdown=array_boton[16].xup+102;
 array_boton[16].ydown=array_boton[16].yup+40;
 array_boton[16].estado= NO_PULSADO;
 array_boton[16].activo= INACTIVO;
 array_boton[16].text_pict= ICONO_GRAF;
 array_boton[16].pos_icono=59969L;
 strcpy(array_boton[16].texto,"");
}

//
//     Esta funcin recorre el array de botones, dibujado segn los campos si
// el botn est pulsado o no, o si est INACTIVo. Adems de mostrar el icono
// grfico o de texto asociado al botn.
//

void test_botones(void)
{
 extern BOTON array_boton[17];
 int i;
 int temp;
 extern GRaton raton;

 for(i=0;i<MAX_BOTONES;i++)
	{
	 if(array_boton[i].activo!= INACTIVO)
		{
		 if(array_boton[i].estado== NO_PULSADO)       //El botn no est pulsado
			{
			 desactivar_boton(array_boton[i].xup,array_boton[i].yup,
			 array_boton[i].xdown-array_boton[i].xup,
			 array_boton[i].ydown-array_boton[i].yup,2);
			}
		 if(array_boton[i].text_pict==ICONO_TEXTO)    // Tiene un icono de texto
			 {

			  temp=(array_boton[i].xup+array_boton[i].xdown)/2;
			  raton.OcultaCursor();
			  setfillstyle(SOLID_FILL,LIGHTGRAY);
			  bar(array_boton[i].xup+5,array_boton[i].yup+5,array_boton[i].xdown-5,array_boton[i].ydown-5);
			  setcolor(RED);
			  settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
			  settextjustify(CENTER_TEXT,CENTER_TEXT);
			  outtextxy(temp,(array_boton[i].yup+array_boton[i].ydown)/2,array_boton[i].texto);
			  raton.MuestraCursor();
			 }
		 else
			 {
			  //  CARGAR ICONO
			  cargar_icono(i,"icons.dat");
			 }
		}
	 else
		// El botn est inactivo
		 {
		  inactivar_boton(array_boton[i]);
		 }
	}
}

//
//    Funcin que carga el icono grfico de fichero y lo pinta en el botn.
//
void cargar_icono(int N_boton,char *nombre)
{
 extern BOTON array_boton[17];
 int fich;
 unsigned TAMICONO,tamx,tamy;
 extern unsigned char far *buf1;
 extern GRaton raton;

 // Abre el fichero y se posiciona en el comienzo del icono.
 if ((fich = open(nombre, O_RDWR | O_BINARY )) == -1)
			perror("Error:");
 lseek(fich,(long) array_boton[N_boton].pos_icono, SEEK_SET);
 // Calcula las dimensiones del botn.
 tamy= array_boton[N_boton].ydown-array_boton[N_boton].yup-8;
 tamx= array_boton[N_boton].xdown-array_boton[N_boton].xup-8;
 TAMICONO= tamy*tamx;
 // Lee el icono del fichhero y cierra el fichero.
 _read(fich,buf1,TAMICONO);
 close ( fich );
 // Dibuja en pantalla el icono.
 raton.OcultaCursor();
 showTFE256 (array_boton[N_boton].xup+5, array_boton[N_boton].yup+5,
			 buf1,tamx,tamy);
 raton.MuestraCursor();
}


//
//                     F   U   N   C   I   O   N   E   S
//

//
// Funcin que dibuja un botn en pantalla, en el punto que se le pasa. Y con
// las dimensiones fijadas
//     OPC = 0 Botn desactivado
//     OPC = 1 Botn activado
//
void dibujar_boton(int xup,int yup,int tamx,int tamy,int grosor,
			  int COLOR_BOTON,int OPC)
{
 extern GRaton raton;

// raton.OcultaCursor();
 if(OPC == BOTON_UP)
	 boton_up(xup,yup,tamx,tamy,grosor,COLOR_BOTON);
 else
	 if(OPC == BOTON_DOWN)
		 boton_down(xup,yup,tamx,tamy,grosor,COLOR_BOTON);
// raton.MuestraCursor();
}


void dibujar_boton2(int xup,int yup,int tamx,int tamy,int grosor,int COLOR_BOTON)
{
 setfillstyle(SOLID_FILL,COLOR_BOTON);
 bar(xup+grosor+3,yup+grosor+3, xup+tamx-grosor-2,yup+tamy-grosor-2);
}
